#define OEMRESOURCE
#include <windows.h>
#include <commctrl.h>
#include "MZtrans.h"

#include "ftd2xx.h"

//#include "giveio.h"
//#include "inout.h"

//unsigned short data_port    = 0x03bc;  //  0x0378;
//unsigned short status_port  = 0x03bd;  //  0x0379;
//unsigned short control_port = 0x03be;  //  0x037a;

//char *FT245_desc = "FT245R USB FIFO";
char *FT245_desc = "MZ-700 USB-LPT I/F";

#define SIZE(x) (int)(sizeof(x) / sizeof(x[0]))

HINSTANCE	hInst;
HANDLE		hThread;
HANDLE		hWatchThread;
HWND		hwnd;
HWND		hwTxt1, hwTxt2;
HFONT		hfon;

int stop_thread;
int dummy;

FT_HANDLE	 ftHandle;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
DWORD WINAPI fnThread(LPVOID);

unsigned char infobuf[128];
unsigned char databuf[65536];
unsigned char *sendbuf;
int sendsiz;

/*----------------------------------------------------------------
	Xe[^XeLXg
  ----------------------------------------------------------------*/
void setStatusTxt(char *str) {
	if (!hwTxt2) return;
	SetWindowText(hwTxt2, str);
}

/*----------------------------------------------------------------
	t@C֏o
  ----------------------------------------------------------------*/
char *errmsg;

int writefile(HANDLE fh, LPVOID buf, DWORD size) {
	DWORD dummy;
	if (!WriteFile(fh, buf, size, &dummy, NULL)) {
	    errmsg = "t@C̓ǂݍ݃G[";
	    return 0;
	}
	if (size != dummy) {
	    errmsg = "t@Cɏ߂܂";
	    return 0;
	}
	return 1;
}

void saveMZTfile() {
	OPENFILENAME ofn;
	HANDLE fh;
	int i, j, skipspc, lastspc, capital;
	unsigned char fn[256];
	char szSaveFile[MAX_PATH];
	char szSaveFileName[MAX_PATH];

	memset(&ofn, 0, sizeof(OPENFILENAME));

	/* translate filename */
	szSaveFile[0] = szSaveFileName[0] = 0;
	skipspc = 1;
	lastspc = 0;
	capital = 1;
	for (i=1, j=0; i<18; i++) {
	    unsigned char c;
	    c = infobuf[i];
	    if (c == ' ') {
		if (skipspc) continue;
		lastspc = j;
		szSaveFile[j++] = '_';
	    } else if (c >= 'A' && c <= 'Z') {
		skipspc = lastspc = 0;
		if (!capital) c += 0x20;
		szSaveFile[j++] = c;
	    } else if (c >= '0' && c <= '9') {
		skipspc = lastspc = 0;
		szSaveFile[j++] = c;
	    } else if (c >= 0x81 && c <= 0xbf) {
		skipspc = lastspc = 0;
		szSaveFile[j++] = (char)(c + 0x20);
	    } else if (c == 0x0d || c == 0x00) {
		break;
	    } else if (c == 0x05) {
		capital ^= 1;
	    } else {
		skipspc = lastspc = 0;
		szSaveFile[j++] = '_';
	    }
	}
	if (lastspc) j = lastspc;
	szSaveFile[j++] = '.';
	szSaveFile[j++] = 'M';
	szSaveFile[j++] = 'Z';
	szSaveFile[j++] = 'T';
	szSaveFile[j] = 0;

	errmsg = 0;

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = "MZe[vC[W(*.mzt)\0*.mzt\0\0";
	ofn.lpstrFile = szSaveFile;
	ofn.lpstrFileTitle = szSaveFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = sizeof(szSaveFileName);
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "MZT";
	ofn.lpstrTitle = "e[vC[W̕ۑ";

	if(GetSaveFileName(&ofn) == 0) return;

	fh = CreateFile(szSaveFile, GENERIC_WRITE, 0, 0, CREATE_ALWAYS,
			   FILE_ATTRIBUTE_NORMAL, NULL);
	if (fh == INVALID_HANDLE_VALUE) {
	    fh = CreateFile(fn, GENERIC_WRITE, 0, NULL, CREATE_NEW,
			    FILE_ATTRIBUTE_NORMAL, NULL);
	    if (fh == INVALID_HANDLE_VALUE) {
		errmsg = "t@C쐬ł܂";
		goto xit;
	    }
	}

	/* write file header */
	if (!writefile(fh, &infobuf, 128)) goto xit;

	/* write file body */
	i = infobuf[18] + (infobuf[19] << 8);
	if (!writefile(fh, &databuf, i)) goto xit;

	/* done! */
	errmsg = 0;

xit:	if (errmsg) {
	    MessageBox(NULL, errmsg, NULL, MB_OK);
	}
	CloseHandle(fh);
}

char szFile[MAX_PATH];
char szFileName[MAX_PATH];
FILETIME fileLastUpdated;
unsigned char *loadfile(DWORD *siz) {
	DWORD dwSize = 0L;
	OPENFILENAME ofn;
	HANDLE hFile;
	DWORD dwAccBytes;
	WIN32_FILE_ATTRIBUTE_DATA fattr;
	unsigned char *filebuf;
	if (!szFileName[0]) return NULL;
	hFile = CreateFile(szFileName, GENERIC_READ, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	dwSize = GetFileSize(hFile, NULL);
	filebuf = (unsigned char *)GlobalAlloc(GPTR, dwSize);
	if (filebuf == NULL) goto xit;
	SetFilePointer(hFile, 0, 0, FILE_BEGIN);
	ReadFile(hFile, filebuf, dwSize, &dwAccBytes, NULL);
	GetFileAttributesEx(szFile, GetFileExInfoStandard, &fattr);
	fileLastUpdated = fattr.ftLastWriteTime;
xit:	CloseHandle(hFile);
	*siz = dwSize;
	return filebuf;
}
unsigned char *OpenMyFile(HWND hWnd, DWORD *siz)
{
	int r;
	DWORD dwSize = 0L;
	OPENFILENAME ofn;
	HANDLE hFile;
	DWORD dwAccBytes;
	unsigned char *filebuf;

	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = "MZe[vC[W(*.mzt)\0*.mzt\0All files(*.*)\0*.*\0\0";
	ofn.lpstrFile = szFileName;
	ofn.lpstrFileTitle = szFile;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = sizeof(szFile);
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "mzt";
	ofn.lpstrTitle = "e[vC[W̑I";

	if(GetOpenFileName(&ofn) == 0)
	    return NULL;

/*	hFile = CreateFile(szFileName, GENERIC_READ, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	dwSize = GetFileSize(hFile, NULL);
	filebuf = (unsigned char *)GlobalAlloc(GPTR, dwSize);
	if (filebuf == NULL) goto xit;
	SetFilePointer(hFile, 0, 0, FILE_BEGIN);
	ReadFile(hFile, filebuf, dwSize, &dwAccBytes, NULL);
xit:	CloseHandle(hFile);*/
	filebuf = loadfile(siz);

//	*siz = dwSize;
	return filebuf;
}

DWORD WINAPI fnThreadWatchFile(LPVOID dummy) {
	HANDLE hFolder;
	char szFilePath[MAX_PATH];
	WIN32_FILE_ATTRIBUTE_DATA fattr;

	if (!szFile[0]) return 0;
	strcpy(szFilePath, szFileName);
	szFilePath[strlen(szFileName) - strlen(szFile)] = 0;
	hFolder = FindFirstChangeNotification(szFilePath, FALSE, FILE_NOTIFY_CHANGE_LAST_WRITE);
	if( hFolder == INVALID_HANDLE_VALUE) {
	    return -1;
	}

	for (;;) {
	    if (WaitForSingleObject(hFolder, 500) == WAIT_TIMEOUT) {
		if (stop_thread) break;
		continue;
	    }
	    if (!GetFileAttributesEx(szFile, GetFileExInfoStandard, &fattr)) {
		break;
	    }
	    if (memcmp(&(fattr.ftLastWriteTime), &fileLastUpdated, sizeof(FILETIME))) {
		fileLastUpdated = fattr.ftLastWriteTime; 
		PostMessage(hwnd, WM_COMMAND, IDM_RELOAD, 0);
	    }
	    if (!FindNextChangeNotification(hFolder)) {
		break;
	    }
	}

	FindCloseChangeNotification(hFolder);
	return 0;
}

/* --------------------------------------------------------
   [MZ]		[PC]
    RDP	   -->	SLCT
    D0-D7  -->	D0-D7
    IRT	   -->	PE
    RDA	  <--	STB
    STA	  <--	AUTOFXINIT

MZ <- PC
	1. IRT=H ɂ		IRTRDPH ɂȂ Load command
	2. RDA=L ҂
	3. STAǂݍ
	4. RDP=H ɂ
	5. RDA=H ҂
	6. STAǂݍ
	7. RDP=L ɂ
	8. 2ɖ߂

MZ -> PC			RDPIRTH ɂȂ Save command
	1. RDA=H ҂
	2. Data
	3. RDP=H ɂ
	4. RDA=L ҂
	5. RDP=L ɂ
	6. 1ɖ߂
   -------------------------------------------------------- */
//#define STB		0x01
//#define	AUTOFXINIT	0x02
//#define	SLCT		0x10
//#define	PE		0x20
//#define	TRYCNT	200
//
//int wait_RDP(a) {
//	int i;
//	/* RDP ҂ */
//	i = TRYCNT;
//	while (!(_inp(status_port) & SLCT) == a) {
//	    if (stop_thread) return 0;
//	    if (--i == 0) {
//		i = TRYCNT;
//		Sleep(10);
//	    }
//	}
//	return 1;
//}
//
//int write_to_MZ(int dat) {
//	int i, d, m;
//	m = 0x80;
//	for (i=0; i<4; i++) {
//	    /* STA, RDA Zbg */
//	    _outp(control_port, 0x21 + (!(dat & m) << 1));
//	    m >>= 1;
//	    /* RDP=H ҂ */
//	    if (!wait_RDP(1)) return -1;
//	    /* STA, RDA Zbg */
//	    _outp(control_port, 0x20 + (!(dat & m) << 1));
//	    m >>= 1;
//	    /* RDP=L ҂ */
//	    if (!wait_RDP(0)) return -1;
//	}
//}
//
//int read_from_MZ() {
//	int i, d;
//	/* RDP=H ҂ */
//	if (!wait_RDP(1)) return -1;
//	/* Data ǂ */
//	d = _inp(data_port);
//	/* RDA=L ɂ */
//	_outp(control_port, 0x21); /* INPUT, STB=H, AFXI=L */
//	/* RDP=L ҂ */
//	if (!wait_RDP(0)) return -1;
//	/* RDA=H ɂ */
//	_outp(control_port, 0x20); /* INPUT, STB=L, AFXI=L */
//	return d;
//}
//
///*----------------------------------------------------------------
//	LPT|[g̃Xbh
//  ----------------------------------------------------------------*/
//DWORD WINAPI fnThread(LPVOID dummy) {
//	int i, j, m, d, s;
//	DWORD tc0, tc1;
//
//	/* set LPT port to input */
//	_outp(control_port, 0x20); /* INPUT, STB=L, AFXI=L */
//
//	setStatusTxt("ڑĂ܂");
//	s = 0;
//	while (!stop_thread) {
//		d = _inp(status_port);
//		if ((d & (SLCT|PE)) == (SLCT|PE)) {
//
//		    /* ڑĂȂH */
//		    if (s) {
//			setStatusTxt("ڑĂ܂");
//			s = 0;
//		    }
//
//		} else if (d & SLCT) {
//
//		    setStatusTxt("M...");
//
//		    /* MZ -> PC */
//		    for (i=0; i<128; i++) {
//			d = read_from_MZ();
//			if (d < 0) return 0; /* abort */
//			infobuf[i] = d;
//		    }
//		    m = (infobuf[18] + (infobuf[19] << 8));
//		    for (i=0; i<m; i++) {
//			d = read_from_MZ();
//			if (d < 0) return 0; /* abort */
//			databuf[i] = d;
//		    }
//		    saveMZTfile();
//		    setStatusTxt("ҋ@");
//
//		} else if (d & PE) {
//
//		    if (!sendbuf) continue;
//
//		    tc1 = GetTickCount();
//		    setStatusTxt("M...");
//
//		    /* PC -> MZ */
//		    for (i=0; i<sendsiz; i++) {
//			if (write_to_MZ(sendbuf[i]) < 0) return 0; /* abort */
//			tc0 = GetTickCount();
//			if ((tc0 - tc1) > 1000) {
//			    char tmp[256];
//			    wsprintf(tmp, "M...(%d/%d)", i+1, sendsiz);
//			    setStatusTxt(tmp);
//			    tc1 = tc0;
//			}
//		    }
//
//		    setStatusTxt("ҋ@");
//
//		} else {
//		
//		    if (!s) {
//			setStatusTxt("ҋ@");
//			s = 1;
//		    }
//		}
//		Sleep(100);
//	}
//	return 0;
//}

/*----------------------------------------------------------------
	USB(FT245)̃Xbh

  PCMZ
	F0	GR[obNR}h(MZF0Ԃ)
	0a 0b 0c 0d 0e ...	ab : MoCg(4bit̂ŁA128oCg̃oCiȂ256 25600)
				cd ef gh ... : Mf[^


  MZPC
	F0			GR[obN(PCF0ɑ΂ԓ)
	F1 aa bb cc dd ...	MZ̎M Mf[^̃oCg
				CtH[VubN: 128oCg
				f[^ubN: ÕCtH[VubÑf[^TCY
	F2			MZ̑Mv

  ----------------------------------------------------------------*/
DWORD WINAPI fnThreadFT245(LPVOID dummy) {
	int i, j, k;
        BYTE cmd, *p, b;
	BYTE buf[260];
	DWORD len, l, siz;
	DWORD rxsiz, txsiz, evs;
	DWORD tc0, tc1;
	FT_STATUS ftStatus;

	setStatusTxt("ڑĂ܂");

	/* reset FT245RL device */
	ftStatus = FT_ResetDevice(ftHandle);
	ftStatus = FT_SetTimeouts(ftHandle, 500, /*500*/0);

	cmd = 0xF0;
	ftStatus = FT_Write(ftHandle, &cmd, 1, &len);

	while (!stop_thread) {
		ftStatus = FT_Read(ftHandle, &cmd, 1, &len);
		if (len == 0) {
		    continue;
		}
		if (ftStatus != FT_OK || cmd == 0xFF) {
		    setStatusTxt("ڑĂ܂");
		} else if (cmd == 0xF1) {

		    setStatusTxt("M...");

		    /* MZ -> PC */
		    p = &infobuf[0];
		    for (l = 0; l < 128 && !stop_thread; l += len) {
			ftStatus = FT_Read(ftHandle, p, 128-l, &len);
			p += len;
		    }
		    siz = (infobuf[18] + (infobuf[19] << 8));
		    p = &databuf[0];
		    for (l = 0; l < siz && !stop_thread; l += len) {
			ftStatus = FT_Read(ftHandle, p, siz-l, &len);
			p += len;
		    }
		    if (!stop_thread) {
			/* ]~߂ */
			cmd = 0xF0;
			ftStatus = FT_Write(ftHandle, &cmd, 1, &len);
			saveMZTfile();
			setStatusTxt("ҋ@");
		    }

		} else if (cmd == 0xF2) {

		    if (!sendbuf) continue;

		    tc1 = GetTickCount();
		    setStatusTxt("M...");

		    /* PC -> MZ */
		    siz = sendsiz;
		    l = 0;

		    while (!stop_thread) {
			i = 0;
			k = (siz > 128) ? 128 : siz;
			buf[i++] = (k >> 3) & 0x0F;
			buf[i++] = (k << 1) & 0x0E;
			for (j=0; j<k; j++) {
			    buf[i++] = (sendbuf[l] >> 4) & 0x0F;
			    buf[i++] =  sendbuf[l]       & 0x0F;
			    l++;
			}
			if (k == siz) {
			    buf[i++] = 0x00;
			    buf[i++] = 0x01;
			}

			for (p = buf; i && !stop_thread; p += len, i -= len) {
			    ftStatus = FT_Write(ftHandle, p, i, &len);
			}
			if (stop_thread) break;
			siz -= k;
			if (siz <= 0) {
			    cmd = 0xF0;
			    ftStatus = FT_Write(ftHandle, &cmd, 1, &len);
			    setStatusTxt("M");
			    break;
			}
			tc0 = GetTickCount();
			if ((tc0 - tc1) > 1000) {
			    char tmp[256];
			    wsprintf(tmp, "M...(%d/%d)", sendsiz-siz, sendsiz);
			    setStatusTxt(tmp);
			    tc1 = tc0;
			}
		    }

		} else if (cmd != 0xF0) {
		    /* ȏ? */
		    ftStatus = FT_Purge(ftHandle, FT_PURGE_RX|FT_PURGE_TX);
		    /* R}h𑗂Ă݂ */
		    cmd = 0xF0;
		    ftStatus = FT_Write(ftHandle, &cmd, 1, &len);
		} else {
		    setStatusTxt("ҋ@");
		}
	}
	return 0;
}

void startNewThread() {
	DWORD dummy;
	stop_thread = 0;
//	hThread = CreateThread(NULL, 0, (data_port != 1) ? fnThread : fnThreadFT245, 0, 0, &dummy);
	hThread = CreateThread(NULL, 0, fnThreadFT245, 0, 0, &dummy);
	hWatchThread = CreateThread(NULL, 0, fnThreadWatchFile, 0, 0, &dummy);
}

void stopThread() {
	stop_thread = 1;
	WaitForSingleObject(hWatchThread, INFINITE);
	hWatchThread = NULL;
	if (WaitForSingleObject(hThread, 1000) == WAIT_TIMEOUT) {
	    TerminateThread(hThread, -1);
	}
	hThread = NULL;
	stop_thread = 0;
}

/*---------------------------------------------------------------------------*/
HWND createStaticText(HWND hwnd, int x, int y, char *itxt) {
	RECT r;
	GetClientRect(hwnd, &r);
	return CreateWindow(
		"STATIC",				/* EChENX */
		itxt,					/* EChẼ^Cg */
		WS_CHILD|WS_VISIBLE|SS_LEFT,		/* EChEX^C */
		x, y,					/* EChE\ʒu */
		r.right - x, 18,			/* EChȆ傫 */
		hwnd,					/* eEChẼnh */
		NULL,					/* j[̃nh */
		hInst,					/* CX^X̃nh */
		NULL);					/* 쐬̈ۑp|C^ */
}

HFONT getfont(char *name, int size) {
	LOGFONT lf;

	ZeroMemory(&lf, sizeof(LOGFONT));
	lf.lfHeight		= size;
	lf.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	lf.lfQuality		= DEFAULT_QUALITY;
	lf.lfPitchAndFamily	= DEFAULT_PITCH | FF_DONTCARE;
	lf.lfCharSet		= DEFAULT_CHARSET;
	wsprintf(lf.lfFaceName, "%s", name);
	return CreateFontIndirect(&lf);
}

/*---------------------------------------------------------------------------*/
//const char *keystring = "Software\\Youkan\\MZTrans";
//int use_registory;
//
//DWORD GetRegistoryData(void) {
//	long lerr;
//	HKEY hKey;
//	DWORD dwData, portno;
//	DWORD dwType = REG_DWORD;
//	portno = 0;
//	if (RegOpenKeyEx(HKEY_CURRENT_USER, keystring, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
//	    dwData = sizeof(portno);
//	    lerr = RegQueryValueEx(hKey, "Port", NULL, &dwType, (LPBYTE)&portno, &dwData);
//	    if ((lerr != ERROR_SUCCESS) || (dwType != REG_DWORD)) {
//		portno = 0;
//	    }
//	    if (portno != 0x3bc && portno != 0x378 && portno != 0x278 && portno != 1) {
//		portno = 0;
//	    }
//	}
//	RegCloseKey(hKey);
//	return portno;
//}
//void SetRegistoryData(void) {
//	long lerr;
//	DWORD dwDisposition;
//	HKEY hKey;
//	DWORD dwData, portno;
//	portno = data_port;
//	lerr = RegCreateKeyEx(HKEY_CURRENT_USER, keystring,
//			      NULL, NULL, REG_OPTION_NON_VOLATILE,
//			      KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);
//	if (lerr == ERROR_SUCCESS) {
//	    RegSetValueEx(hKey, "Port", 0, REG_DWORD, (LPBYTE)&portno, sizeof(portno));
//	}
//	RegCloseKey(hKey);
//}
//void DisposeRegistoryData(void) {
//	HKEY hKey;
//	DWORD nrsubkeys;
//	RegDeleteKey(HKEY_CURRENT_USER, keystring);
//	RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Youkan", 0, KEY_READ, &hKey); 
//	nrsubkeys = 0;
//	RegQueryInfoKey(hKey, NULL, NULL, NULL, &nrsubkeys, NULL, NULL, NULL, 
//			NULL, NULL, NULL, NULL);
//	RegCloseKey(hKey);
//	if (nrsubkeys == 0) RegDeleteKey(HKEY_CURRENT_USER, "Software\\Youkan");
//}

/*---------------------------------------------------------------------------*/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow){

//	HWND hwnd;
	MSG  msg;
	WNDCLASSEX  wndclass;
	HACCEL hAccel;
	HMENU hMenu;
//	int giveio_result = GIVEIO_ERROR;
//	DWORD portno;
	FT_STATUS ftStatus;

	hInst = hInstance;

	InitCommonControls();

	/* FT245RL open */
	ftStatus = FT_OpenEx(FT245_desc, FT_OPEN_BY_DESCRIPTION, &ftHandle);
	if (ftStatus != FT_OK) {
	    ftHandle = NULL;
	}

//	/* WXgɃp|[g̔ԍ΁Ag */
//	portno = GetRegistoryData();
//	/* USBŎgpłȂ΁AGIVEIO.SYS I[v */
//	if (portno != 1) {
//	    /* GIVEIO open */
//	    giveio_result = giveio_start();
//	}
//	/* GIVEIO.SYS ΁AIUSBɂ */
//	if (giveio_result == GIVEIO_ERROR) {
//	    data_port    = 1;
//	    status_port  = 1;
//	    control_port = 1;
//	}
//	if (portno) {
//	    data_port	 = portno;
//	    status_port	 = portno + 1;
//	    control_port = portno + 2;
//	    use_registory = 1;
//	}

	wndclass.cbSize        = sizeof(wndclass);        /* \̂̑傫 */
	wndclass.style         = CS_HREDRAW | CS_VREDRAW; /* X^C */
	wndclass.lpfnWndProc   = WndProc;                 /* bZ[W֐ */
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;               /* vÕnh */
	wndclass.hIcon         = LoadIcon(hInstance, "myIcon"); /* ACR */
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);     /* J[\ */
//	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); /* uV */
	wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW); /* uV */
	wndclass.lpszMenuName  = "MZTMenu";              /* j[ */
	wndclass.lpszClassName = "MZtrans";   /* NX */
	wndclass.hIconSm       = 0;

	RegisterClassEx(&wndclass); /* EChENXo^ */

	hwnd = CreateWindow(
           "MZtrans",					/* EChENX */
	   "MZtrans",					/* EChẼ^Cg */
            WS_OVERLAPPEDWINDOW & (~WS_THICKFRAME),	/* EChEX^C */
            32/*CW_USEDEFAULT*/, 32/*CW_USEDEFAULT*/,		/* EChE\ʒu */
            240,/*temp*/				/* EChȆ傫 */
            120,/*temp*/
            NULL,					/* eEChẼnh */
            NULL,					/* j[̃nh */
            hInstance,					/* CX^X̃nh */
            NULL);					/* 쐬̈ۑp|C^ */

	ShowWindow(hwnd,iCmdShow);      /* EChE\ */
	UpdateWindow(hwnd);

	hAccel = LoadAccelerators(hInst, "myAccel");

//	hMenu = GetMenu(hwnd);
//	if (data_port ==     1) CheckMenuRadioItem(hMenu, IDM_USB, IDM_278, IDM_USB, MF_BYCOMMAND);
//	if (data_port == 0x3bc) CheckMenuRadioItem(hMenu, IDM_USB, IDM_278, IDM_3BC, MF_BYCOMMAND);
//	if (data_port == 0x378) CheckMenuRadioItem(hMenu, IDM_USB, IDM_278, IDM_378, MF_BYCOMMAND);
//	if (data_port == 0x278) CheckMenuRadioItem(hMenu, IDM_USB, IDM_278, IDM_278, MF_BYCOMMAND);
//	if (giveio_result == GIVEIO_ERROR) {
//	    EnableMenuItem(hMenu, IDM_3BC, MF_GRAYED);
//	    EnableMenuItem(hMenu, IDM_278, MF_GRAYED);
//	    EnableMenuItem(hMenu, IDM_378, MF_GRAYED);
//	}
	if (ftHandle == NULL) {
//	    EnableMenuItem(hMenu, IDM_USB, MF_GRAYED);
	    MessageBox(hwnd, "MZ-700 LPT-USB I/FڑĂ܂", "Error", MB_OK);
	    goto xit;
	}
//	if (use_registory) {
//	    EnableMenuItem(hMenu, IDM_CLEARREG, MF_ENABLED);
//	}

	startNewThread();

	while (GetMessage(&msg, NULL, 0, 0)) {
	    if (!TranslateAccelerator(hwnd, hAccel, &msg)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	    }
	}

	stopThread();

	/* FT245RL close */
	if (ftHandle != NULL) FT_Close(ftHandle);

//	/* GIVEIO close */
//	if (giveio_result != GIVEIO_ERROR) giveio_stop(giveio_result);
xit:
	if (sendbuf) GlobalFree(sendbuf);

	return msg.wParam;
}

void setcursor(int wait) {
	SetCursor(LoadCursor(NULL, (wait) ? IDC_WAIT : IDC_ARROW));
}

/*---------------------------------------------------------------------------*/

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {
	HDC hdc;
	PAINTSTRUCT ps;
	int i;
	char c;

	switch (iMsg) {

	    case WM_COMMAND:
		switch (LOWORD(wParam)) {
		    case IDM_ABOUT:
			MessageBox(hwnd, "MZ-700 <--> PC t@C] v0.03\n\tby youkan", "About", MB_OK);
			return 0;

		    case IDM_TEST: {
			FT_STATUS ftStatus;
			DWORD txsiz, rxsiz, d;
			BYTE b;
			if (ftHandle != NULL) FT_Close(ftHandle);
			ftStatus = FT_OpenEx(FT245_desc, FT_OPEN_BY_DESCRIPTION, &ftHandle);
			if (ftStatus == FT_OK) {
			    MessageBox(hwnd, "FT_OpenEx OK!", "Debug", MB_OK);
			    b = 0xF0;
			    ftStatus = FT_Write(ftHandle, &b, 1, &d);
			    if (ftStatus == FT_OK) {
				MessageBox(hwnd, "FT_Write OK!", "Debug", MB_OK);
			    }
			    ftStatus = FT_GetStatus(ftHandle, &rxsiz, &txsiz, &d);
			    if (ftStatus == FT_OK) {
				char buf[256];
				wsprintf(buf, "TxSiz = %d, RxSiz = %d", txsiz, rxsiz);
				MessageBox(hwnd, buf, "FT_GetStatus", MB_OK);
			    }
			    if (rxsiz != 0) {
				ftStatus = FT_Read(ftHandle, &b, 1, &d);
				if (ftStatus == FT_OK && d == 1) {
				    char buf[256];
				    wsprintf(buf, "FT_Read OK! (%02X)", b);
				    MessageBox(hwnd, buf, "Debug", MB_OK);
				}
			    }
			    FT_Close(ftHandle);
			}
			return 0;
		    }

		    case IDM_OPEN: {
			unsigned char *p;
			DWORD siz;
			p = OpenMyFile(hwnd, &siz);
			if (p != NULL) {
			    stopThread();
			    if (sendbuf) GlobalFree(sendbuf);
			    SetWindowText(hwTxt1, szFile);
			    sendbuf = p;
			    sendsiz = siz;
			    startNewThread();
			    EnableMenuItem(GetMenu(hwnd), IDM_RELOAD, MF_ENABLED);
			    InvalidateRect(hwnd, NULL, NULL);
			}
			return 0;
		    }

		    case IDM_RELOAD: {
			unsigned char *p;
			DWORD siz;
			if (szFileName[0] && (p = loadfile(&siz)) != NULL) {
			    stopThread();
			    if (sendbuf) GlobalFree(sendbuf);
			    SetWindowText(hwTxt1, szFile);
			    SetWindowText(hwTxt2, "[h܂");
			    sendbuf = p;
			    sendsiz = siz;
			    startNewThread();
			    InvalidateRect(hwnd, NULL, NULL);
			} else {
			    /* failed to reload */
			    EnableMenuItem(GetMenu(hwnd), IDM_RELOAD, MF_GRAYED);
			}
			return 0;
		    }

		    case IDM_RESET:
			{
			    FT_STATUS ftStatus;
			    if (ftHandle == NULL) {
				stopThread();
				ftStatus = FT_OpenEx(FT245_desc, FT_OPEN_BY_DESCRIPTION, &ftHandle);
				if (ftStatus == FT_OK) {
//				    EnableMenuItem(GetMenu(hwnd), IDM_USB, MF_ENABLED);
				    startNewThread();
				}
			    } else {
				SetWindowText(hwTxt2, "ڑZbgĂ܂...");
				stopThread();
				ftStatus = FT_CyclePort(ftHandle);
				if (ftStatus == FT_OK) {
				    FT_Close(ftHandle);
				    do {
					ftStatus = FT_OpenEx(FT245_desc, FT_OPEN_BY_DESCRIPTION, &ftHandle);
				    } while (ftStatus != FT_OK);
				    FT_ResetDevice(ftHandle);
				}
				startNewThread();
				setStatusTxt("Đڑ܂");
			    }
			}
			return 0;

		    case IDM_END:
			SendMessage(hwnd, WM_CLOSE, 0, 0L);
			return 0;

//		    case IDM_USB:
//		    case IDM_3BC:
//		    case IDM_378:
//		    case IDM_278:
//			stopThread();
//			i = LOWORD(wParam);
//			CheckMenuRadioItem(GetMenu(hwnd), IDM_USB, IDM_278, i, MF_BYCOMMAND);
//			switch (i) {
//			    case IDM_USB:
//				data_port    = 1;
//				status_port  = 1;
//				control_port = 1;
//				break;
//			    case IDM_3BC:
//				data_port    = 0x3bc;
//				status_port  = 0x3bd;
//				control_port = 0x3be;
//				break;
//			    case IDM_378:
//				data_port    = 0x378;
//				status_port  = 0x379;
//				control_port = 0x37a;
//				break;
//			    case IDM_278:
//				data_port    = 0x278;
//				status_port  = 0x279;
//				control_port = 0x27a;
//				break;
//			}
//			if (use_registory ||
//			    MessageBox(hwnd, "|[g̐ݒWXgɕۑ܂H",
//					     "MZtrans", MB_YESNO) == IDYES) {
//				SetRegistoryData();
//				use_registory = 1;
//				EnableMenuItem(GetMenu(hwnd), IDM_CLEARREG, MF_ENABLED);
//			}
//			startNewThread();
//			break;
//
//		    case IDM_CLEARREG:
//			DisposeRegistoryData();
//			EnableMenuItem(GetMenu(hwnd), IDM_CLEARREG, MF_GRAYED);
//			break;

		    default:
			break;
		}
		break;

	    case WM_CREATE:
		hfon = getfont("lr oSVbN", 12);
		hwTxt1 = createStaticText(hwnd, 50, 14, "e[v̓ZbgĂ܂");
		hwTxt2 = createStaticText(hwnd, 8, 56, "...");
		SendMessage(hwTxt1, WM_SETFONT, (WPARAM)hfon, (LPARAM)TRUE);
		SendMessage(hwTxt2, WM_SETFONT, (WPARAM)hfon, (LPARAM)TRUE);
		ShowWindow(hwnd, SW_SHOW);
		return 0;

	    case WM_PAINT: {
		char *p;
		RECT r;
		hdc=BeginPaint(hwnd,&ps);
		DrawIcon(hdc, 8, 4, LoadIcon (hInst, "myIcon"));
		GetClientRect(hwnd, &r);
		DrawEdge(hdc, &r, EDGE_ETCHED, BF_TOP);
		EndPaint(hwnd,&ps);
		return 0;
	    }

	    case WM_DESTROY:
		if (hfon) DeleteObject(hfon);
		PostQuitMessage(0);
		stop_thread = 1;
		return 0;

//	    case WM_CHAR: {
//		c = (char)wParam;
//		if (c == 'r' && szFileName[0]) {
//			unsigned char *p;
//			DWORD siz;
//			p = loadfile(&siz);
//			if (p != NULL) {
//			    stop_thread = 1;
//			    WaitForSingleObject(hThread, INFINITE);
//			    if (sendbuf) GlobalFree(sendbuf);
//			    SetWindowText(hwTxt1, szFile);
//			    SetWindowText(hwTxt2, "[h܂");
//			    sendbuf = p;
//			    sendsiz = siz;
//			    stop_thread = 0;
//			    startNewThread();
//			    InvalidateRect(hwnd, NULL, NULL);
//			}
//		}
//		return 0;
//	    }

	    case WM_LBUTTONDOWN:
		break;

	    default:
		break;
	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam);

}
